import 'dart:async';

import 'package:ipstack/ipstack.dart';
import 'package:logging/logging.dart';
import 'package:platform_detect2/platform_detect2.dart';
import 'package:sunny_dart/extensions.dart';
import 'package:sunny_dart/helpers/strings.dart';
import 'package:sunny_sdk_core/sunny_sdk_core.dart';
import 'platform_interface.dart';

bool get isPlatformIOS => false;

bool get isPlatformAndroid => false;

bool get isPlatformMacOS => false;

bool get isPlatformWindows => false;

bool get isPlatformLinux => false;

bool get isPlatformWeb => true;

String get platformName => "web";

Map<String, String> get platformEnvironment => {};

bool get canPlatformReadFiles => false;

final _log = Logger("platformInfoWeb");
GeoPoint? geo;

Future<DeviceInfo> loadPlatformInfo() async {
  // List languages = await Devicelocale.preferredLanguages;
  // String locale = await Devicelocale.currentLocale;

  IpStackResponse? auth;
  try {
    /// Remove hard-coded later
    auth = await IpStack.ofBaseUrl("08c386683f65cfe7e4cbeab9e4c05661",
            baseUrl: rproxy.ipstack())
        .requester();
  } catch (e) {
    _log.info("Couldn't get coords: $e");
  }
  return DeviceInfo(
    ipAddress: auth?.ip,
    isSimulator: false,
    locale:
        "${auth?.location?.languages?.firstOrNull()?.code ?? 'en'}-${auth?.countryCode ?? "us"}",
    geo: geo = GeoPoint.of(auth?.latitude, auth?.longitude),
    language: auth?.location?.languages?.firstOrNull()?.code ?? 'en',
    deviceType: "browser",
    software: "browser",
    deviceBrand: browser.name,
    deviceModel: browser.className,
    deviceId: uuid(),
    softwareVersion: "${browser.version}",
  );
}

Future<String> get currentUserTimeZone async {
  return "America/Chicago";
}
