// ignore: avoid_web_libraries_in_flutter
import 'dart:html';

import 'package:flutter/foundation.dart';
import 'package:logging/logging.dart';
import 'package:logging_config/logging_config.dart';
import 'package:pub_semver/pub_semver.dart' as semver;
import 'package:sunny_dart/sunny_dart.dart';
import 'package:sunny_lifecycle/app_info.dart';

Future<AppInfo> onAppInit(
    Level rootLogLevel, FallbackAppInfo fallbackInfo) async {
  configureLogging(
    LogConfig.root(
      rootLogLevel,
      handler: LoggingHandler.console(),
    ),
  );

  return AppInfo(
    appStoreUrl: fallbackInfo.appStoreUrl,
    buildNumber: "-",
    appVersion: semver.Version(1, 0, 0),
    appName: fallbackInfo.appName,
    packageName: fallbackInfo.packageName,
  );
}

void recordFlutterError(FlutterErrorDetails error) {
  FlutterError.dumpErrorToConsole(error);
}

void recordDartError(Object error, StackTrace stackTrace) {
  print(error);
  print(stackTrace);
}

Uri? getStartingUrl() {
  var url = window.location.href;
  return url.toUri();
}

/// Not sure if this is even possible
Stream<Uri> getUriChangeStream() => Stream.empty();
