import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

class FadeAnimationPage<T> extends Page<T> {
  final Widget child;
  final String route;

  FadeAnimationPage({LocalKey? key, required this.child, required this.route})
      : super(key: key);

  Route<T> createRoute(BuildContext context) {
    return PageRouteBuilder(
      settings: this,
      transitionsBuilder: (context, a1, a2, page) {
        var curveTween = CurveTween(curve: Curves.easeIn);
        return FadeTransition(
            opacity: a1.drive(curveTween),
            child: page);
      },
      pageBuilder: (context, animation, animation2) => child,
    );
  }
}
